<vex-page-layout>

  <vex-page-layout-header class="pb-16" fxLayout="column" fxLayoutAlign="center start">
    <div [class.container]="layoutCtrl.value === 'boxed'"
         [class.px-gutter]="layoutCtrl.value === 'fullwidth'"
         class="w-full flex flex-col sm:flex-row justify-between">
      <div>
        <h1 class="title mt-0 mb-1">Desarroladores Creci</h1>
        <vex-breadcrumbs [crumbs]="['Gestión de proyectos', 'Desarrolladores']"></vex-breadcrumbs>
      </div>

  
    </div>
  </vex-page-layout-header>

  <vex-page-layout-content [class.container]="layoutCtrl.value === 'boxed'"
                           [class.px-gutter]="layoutCtrl.value === 'fullwidth'"
                           class="-mt-6">

    <div class="card overflow-auto -mt-16">
      <div class="bg-app-bar px-6 h-16 border-b sticky left-0" fxLayout="row" fxLayoutAlign="start center">
        <h2 class="title my-0 ltr:pr-4 rtl:pl-4 ltr:mr-4 rtl:ml-4 ltr:border-r rtl:border-l" fxFlex="none" fxHide.xs>
          <span *ngIf="selection.isEmpty()">Usuarios</span>
          <span *ngIf="selection.hasValue()">{{ selection.selected.length }}
            Customer<span *ngIf="selection.selected.length > 1">s</span> selected</span>
        </h2>



        <div class="bg-card rounded-full border px-4"
             fxFlex="400px"
             fxFlex.lt-md="auto"
             fxHide.xs
             fxLayout="row"
             fxLayoutAlign="start center">
          <ic-icon [icIcon]="icSearch" size="20px"></ic-icon>
          <input [formControl]="searchCtrl"
                 class="px-4 py-3 border-0 outline-none w-full bg-transparent"
                 placeholder="Buscar..."
                 type="search">
        </div>

        <span fxFlex></span>

        <button class="ml-4" fxFlex="none" fxHide.gt-xs mat-icon-button type="button">
          <mat-icon [icIcon]="icSearch"></mat-icon>
        </button>

        <button [matMenuTriggerFor]="columnFilterMenu"
                class="ml-4"
                fxFlex="none"
                mat-icon-button
                matTooltip="Filter Columns"
                type="button">
          <mat-icon [icIcon]="icFilterList"></mat-icon>
        </button>

        <button (click)="createUserModel()"
                class="ml-4"
                color="primary"
                fxFlex="none"
                mat-mini-fab
                matTooltip="Adicionar desarrollador"
                type="button">
          <mat-icon [icIcon]="icAdd"></mat-icon>
        </button>
      </div>

      <table @stagger [dataSource]="dataSource" class="w-full" mat-table matSort>

        <!--- Note that these columns can be defined in any order.
              The actual rendered columns are set as a property on the row definition" -->

 



        <!-- Text Columns -->
        <ng-container *ngFor="let column of columns; trackBy: trackByProperty">
          <ng-container *ngIf="column.type === 'text'" [matColumnDef]="column.property">
            <th *matHeaderCellDef class="uppercase" mat-header-cell mat-sort-header> {{ column.label }}</th>
            <td *matCellDef="let row" [ngClass]="column.cssClasses" mat-cell>{{ row[column.property] }}</td>
          </ng-container>
        </ng-container>

    

     

        <!-- Action Column -->
        <ng-container matColumnDef="actions">
          <th *matHeaderCellDef mat-header-cell mat-sort-header></th>
          <td *matCellDef="let row" class="w-10 text-secondary" mat-cell>
            <button (click)="$event.stopPropagation()"
                    [matMenuTriggerData]="{ developer: row }"
                    [matMenuTriggerFor]="actionsMenu"
                    mat-icon-button
                    type="button">
              <mat-icon [icIcon]="icMoreHoriz"></mat-icon>
            </button>
          </td>
        </ng-container>

        <tr *matHeaderRowDef="visibleColumns" mat-header-row></tr>
        <tr (click)="updateUserModel(row)"
            *matRowDef="let row; columns: visibleColumns;"
            @fadeInUp
            class="hover:bg-hover trans-ease-out cursor-pointer"
            mat-row></tr>
      </table>

      <mat-paginator [pageSizeOptions]="pageSizeOptions" [pageSize]="pageSize" class="sticky left-0"></mat-paginator>
    </div>

  </vex-page-layout-content>

</vex-page-layout>

<mat-menu #columnFilterMenu="matMenu" xPosition="before" yPosition="below">
  <button (click)="toggleColumnVisibility(column, $event)" *ngFor="let column of columns"
          class="checkbox-item mat-menu-item">
    <mat-checkbox (click)="$event.stopPropagation()" [(ngModel)]="column.visible" color="primary">
      {{ column.label }}
    </mat-checkbox>
  </button>
</mat-menu>

<mat-menu #actionsMenu="matMenu" xPosition="before" yPosition="below">
  <ng-template let-developer="developer" matMenuContent>
    <button (click)="updateUserModel(developer)" mat-menu-item>
      <mat-icon [icIcon]="icEdit"></mat-icon>
      <span>Actualizar</span>
    </button>
    <button (click)="deleteUserModel(developer)" mat-menu-item>
      <mat-icon [icIcon]="icDelete"></mat-icon>
      <span>Eliminar</span>
    </button>
  </ng-template>
</mat-menu>
